// XMLDoc.cpp : Implementierung der Klasse CXMLDoc
//

#include "stdafx.h"
#include "XML.h"

#include "XMLDoc.h"
#include "XMLException.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CXMLDoc

IMPLEMENT_DYNCREATE(CXMLDoc, CDocument)

BEGIN_MESSAGE_MAP(CXMLDoc, CDocument)
END_MESSAGE_MAP()


// CXMLDoc-Erstellung/Zerstrung

CXMLDoc::CXMLDoc()
{
	// TODO: Hier Code fr One-Time-Konstruktion einfgen
	//Erzeugen der Punktliste:
	this->listPoints = new CList<CPoint, CPoint> ();
}

CXMLDoc::~CXMLDoc()
{
	//Lschen der Punktliste:
	this->listPoints->RemoveAll();
	delete this->listPoints;

}

BOOL CXMLDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)
	
	//Die Liste der Punkte nur leeren (erforderlich z.B. beim Laden).
	this->listPoints->RemoveAll();

	return TRUE;
}




// CXMLDoc-Serialisierung

void CXMLDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		
		//Den MFC-Speicherungsmechanismus umgehen und XML erzeugen:
		MSXML2::IXMLDOMDocumentPtr domDocument; //pointer to the xml document
		::CoInitialize(NULL);

		HRESULT hr = domDocument.CreateInstance (CLSID_DOMDocument);
		//Gem Doku mte das auch so gehen !
		//HRESULT hr = domDocument.CreateInstance (__uuidof(MSXML2::DOMDocument30));
		if (FAILED (hr) )
		{
			//_com_error ist eine Kapselklasse um COM-Fehler.
			_com_error er (hr);
			//Saubere Exception mit Fehlermeldung auslsen:
			CString sError = _T("Fehler beim Initialisieren von MSXML: ");
			sError += er.ErrorMessage ();
			throw new CXMLException ( sError);
		}

		//Damit die DOCTYPE-Deklaration eingebunden werden kann
		//MUSS hier das XML als String erzeugt werden ! Die Methoden 
		//des CodeDom knnen wir nicht verwenden, die untersttzen das nicht !
		CString strXML;
		strXML = _T("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		//DUMMERWEISE ist das XML nach dem Laden dann jedesmal leer.
		//Ich kann es mir bisher nicht erklren, deshalb habe ich die DOCTYPE-Deklaration weggelassen.
		//Im Folgenden drei Varianten:
		//a) Lokaler Webserver (im Beispiel: Tomcat auf Port 8080)
		//strXML += _T("<!DOCTYPE points PUBLIC \"XML-Beispiel Softwaretechnik 2006 FH Wiesbaden\" \"http://localhost:8080/points.dtd\">");
		//b) Dateisystem-Referenz:
		//strXML += _T("<!DOCTYPE points PUBLIC \"XML-Beispiel Softwaretechnik 2006 FH Wiesbaden\" \"file://c:/temp/points.dtd\">");
		//c) Meine FH-Seite:
		strXML += _T("<!DOCTYPE points PUBLIC \"XML-Beispiel Softwaretechnik 2006 FH Wiesbaden\" \"http://www.informatik.fh-wiesbaden.de/~knauf/SWT2006/MFCSchnipsel/points.dtd\">");

		//Jetzt das Document-Element und die Subelemente reinhngen:
		strXML += _T("<points>");
		for (int intIndex = 0; intIndex < this->GetPointNumber(); intIndex++)
		{
			CPoint pointAktuell = this->GetPointAt (intIndex);
			CString sFormat;
			sFormat.Format (_T("<point x=\"%d\" y=\"%d\" />"), pointAktuell.x, pointAktuell.y);
			strXML += sFormat;
		}
		strXML += _T("</points>");

		//Wir speichern das Ding. Vorgehen dabei: in ein XML-Document laden
		//und dieses dann speichern !
		//Dazu mssen wir den XML-String in einen COM-tauglichen String umwandeln:
		BSTR sXMLBSTR = SysAllocString(strXML);
		//Da wir hier das XML laden kann es sein dass es schon
		//einen Parse-Fehler gibt ! Also: Fehlerbehandlung !
		if (domDocument->loadXML(sXMLBSTR ) == FALSE)
		{
			//Fehlerbehandlung: XML-Fehler mit ErrorCode und Reason ausgeben.
			//XML-Fehler werden von IXMLDOMParseError gekapselt.
			MSXML2::IXMLDOMParseErrorPtr parseError = domDocument->parseError;
			//Zuerst den ErrorCode holen (der wird nicht viel Info liefern)
			long lngErrorCode;
			parseError->get_errorCode (&lngErrorCode);
			//Jetzt den Reason (Fehlertext). Hilfsklasse "ComBSTR" bietet ein paar Hilfsmethoden,
			//u.a. fr CString-Konvertierung.
			CComBSTR bstrReason;
			parseError->get_reason (&bstrReason);
			//Und jetzt Ausgabe:
			CString strError;
			strError.Format (_T("Fehler beim Laden der XML-Datei ! Errorcode=%d, Reason: "), lngErrorCode);
			strError += bstrReason;
			throw new CXMLException (strError );
		}
		//String wieder freigeben.
		SysFreeString(sXMLBSTR);

		//Wenn wir uns hier per "domDocument->xml" den aktuellen
		//XML-String holen wrde uns auffallen dass das Encoding
		//scheinbar nicht vorhanden ist. Erst beim Speichern wird das 
		//wieder gesetzt.
		//CString sXMLTemp = domDocument->xml;

		//Damit wir speichern knnen mssen wir die Datei im CArchive
		//schlieen !
		ar.GetFile()->Close();


		//Die Datei ffnen. Dazu den Dateinamen in eine COM-VARIANT
		//umwandeln.
		BSTR sFileNameBSTR = SysAllocString( ar.m_strFileName );
		//bstr_t sFileNameBSTR ( ar.m_strFileName );
		VARIANT myVariant;
		myVariant.vt = VT_BSTR;
		myVariant.bstrVal = sFileNameBSTR;
		SysFreeString(sFileNameBSTR);

		//Speichern:
		domDocument->save (myVariant);
		
		//Datei im Archive wieder ffnen, sonst gibt es einen Crash...
		ar.GetFile()->Open(ar.m_strFileName, CFile::modeReadWrite);
	}
	else
	{
		//Laden der XML-Datei zum Archive.
		//Dazu: das CFile im Archive schlieen und erst anschlieend wieder ffnen !
		
		//Bei Fehlern: CXMLException werfen. Diese ist von CFileException
		//abgeleitet. In CDocument werden die Meldungen aus CFileExceptions 
		//per MessageBox an den User gegeben und das Laden als "gescheitert" behandelt.

		//Zuerst einmal die Datei im CArchive schlieen:
		ar.GetFile()->Close();

		MSXML2::IXMLDOMDocumentPtr domDocument; //pointer to the xml document
		::CoInitialize(NULL);

		HRESULT hr = domDocument.CreateInstance (CLSID_DOMDocument);
		if (FAILED (hr) )		//#define FAILED(Status) ((HRESULT)(STATUS) < 0)
		{
			//_com_error ist eine Kapselklasse um COM-Fehler.
			_com_error er (hr);
			//Saubere Exception mit Fehlermeldung auslsen:
			CString sError = _T("Fehler beim Initialisieren von MSXML: ");
			sError += er.ErrorMessage ();
			throw new CXMLException ( sError);
		}

		//ACHTUNG: unser Document verwendt eine DTD ! 
		//Bei XML-Dokumenten mit DTD ldt der Parser nur den XML-Header,
		//der DOM-Baum wird aber noch nicht aufgebaut !
		//Erkennbar daran dass das Abrufen des "documentElement"
		//weiter unten NULL zurckliefern wrde !
		//Nur durch Abrufen der ChildNodes kmen wir in diesem Fall weiter.
		//Aber besser ist es hier das asynchrone Laden zu verhindern: direkt
		//alles auf einen Schlag laden !
		domDocument->async = _variant_t (false);
	
		//Aus der Datei laden:
		BSTR sFileNameBSTR = SysAllocString( ar.m_strFileName );
		//bstr_t sFileNameBSTR ( ar.m_strFileName);
		VARIANT myVariant;
		myVariant.vt = VT_BSTR;
		myVariant.bstrVal = sFileNameBSTR;
		SysFreeString(sFileNameBSTR);
		if (domDocument->load (myVariant) == FALSE)
		{
			//Fehlerbehandlung: XML-Fehler mit ErrorCode und Reason ausgeben.
			//XML-Fehler werden von IXMLDOMParseError gekapselt.
			MSXML2::IXMLDOMParseErrorPtr parseError = domDocument->parseError;
			//Zuerst den ErrorCode holen (der wird nicht viel Info liefern)
			long lngErrorCode;
			parseError->get_errorCode (&lngErrorCode);
			//Jetzt den Reason (Fehlertext). Hilfsklasse "ComBSTR" bietet ein paar Hilfsmethoden,
			//u.a. fr CString-Konvertierung.
			CComBSTR bstrReason;
			parseError->get_reason (&bstrReason);
			//Und jetzt Ausgabe:
			CString strError;
			strError.Format (_T("Fehler beim Laden der XML-Datei ! Errorcode=%d, Reason: "), lngErrorCode);
			strError += bstrReason;
			throw new CXMLException (strError );
		}
		
		//Auswerten des Root-Elements "points":
		MSXML2::IXMLDOMElementPtr docElementPoints;
		docElementPoints = domDocument->documentElement;
		if (docElementPoints == NULL)
			throw new CXMLException (_T("Kein Wurzelelement vorhanden !") );
		//Stimmt der Name eigentlich ?
		_bstr_t bstrTagName = docElementPoints->GettagName();
		if (bstrTagName != _bstr_t ("points") )
		{
			CString sError = _T("Kein Wurzelelement 'points' vorhanden, Wurzelelement ist '");
			sError.Append (bstrTagName);
			sError += "'";
			throw new CXMLException (sError);
		}

		//Dieses Element durchlaufen:
		MSXML2::IXMLDOMElementPtr docElementPoint = docElementPoints->firstChild;
		while (docElementPoint != NULL)
		{
			//Prfung auf gltigen Namen:
			bstrTagName = docElementPoint->GettagName();
			if (bstrTagName != _bstr_t ("point") )
			{
				CString sError = _T("Das Unterelement muss 'point' heien, gefunden wurde '");
				sError.Append (bstrTagName);
				sError += "'";
				throw new CXMLException (sError);
			}

			//Die Attribute dieses Points holen:
			MSXML2::IXMLDOMNamedNodeMapPtr namedNodeMap = docElementPoint->Getattributes ();
			//Suchen der Attribute "x" und "y":
			MSXML2::IXMLDOMAttributePtr docAttributeX = namedNodeMap->getNamedItem ("x");
			//Fehlercheck:
			if (docAttributeX == NULL)
				throw new CXMLException (_T("Kein Attribut 'x' gefunden !") );
			MSXML2::IXMLDOMAttributePtr docAttributeY = namedNodeMap->getNamedItem ("y");
			if (docAttributeY == NULL)
				throw new CXMLException (_T("Kein Attribut 'y' gefunden !") );

			//Den Wert der Attribute extrahieren und in Integer umwandeln:
			_bstr_t bstrValue = docAttributeX->value;
			int intX = atoi ( bstrValue);
			bstrValue = docAttributeY->value;
			int intY = atoi ( bstrValue);
			
			//Neuen Punkt zufgen:
			this->AddPoint ( intX, intY);

			//Nchsten Knoten holen (falls vorhanden):
			docElementPoint = docElementPoint->nextSibling;
		}

		//Datei im Archive wieder ffnen, sonst gibt es einen Crash...
		ar.GetFile()->Open(ar.m_strFileName, CFile::modeRead);
	}

}


// CXMLDoc-Diagnose

#ifdef _DEBUG
void CXMLDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CXMLDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CXMLDoc-Befehle

//Hinzufgen eines Punkts zur Liste.
void CXMLDoc::AddPoint(int int_X, int int_Y)
{
	this->listPoints->AddTail ( CPoint (int_X, int_Y) );
}

//Abrufen der Anzahl der angeklickten Punkte:
int CXMLDoc::GetPointNumber()
{
	return (int) this->listPoints->GetCount();
}

//Abrufen des Punkts "int_Index" innerhalb der Liste.
CPoint CXMLDoc::GetPointAt(int int_Index)
{
	//Prfen ob der Index gltig ist:
	//(Hier sollte im Idealfall eine Exception ausgelst werden).
	if (int_Index < 0 || int_Index >= this->GetPointNumber() )
		return CPoint (0, 0);

	CPoint point = (CPoint) this->listPoints->GetAt ( this->listPoints->FindIndex (int_Index) );
	return point;
}

