// XMLView.cpp : Implementierung der Klasse CXMLView
//

#include "stdafx.h"
#include "XML.h"

#include "XMLDoc.h"
#include "XMLView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CXMLView

IMPLEMENT_DYNCREATE(CXMLView, CView)

BEGIN_MESSAGE_MAP(CXMLView, CView)
	// Standarddruckbefehle
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// CXMLView-Erstellung/Zerstrung

CXMLView::CXMLView()
{
	// TODO: Hier Code zur Konstruktion einfgen

}

CXMLView::~CXMLView()
{
}

BOOL CXMLView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

// CXMLView-Zeichnung

void CXMLView::OnDraw(CDC* pDC)
{
	CXMLDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: Code zum Zeichnen der systemeigenen Daten hinzufgen

	//Alle bisher angeklickten Punkte einzeichnen:
	for (int intIndex = 0; intIndex < pDoc->GetPointNumber(); intIndex++)
	{
		CPoint pointAktuell = pDoc->GetPointAt (intIndex);
		pDC->Ellipse (pointAktuell.x - 2, pointAktuell.y - 2, pointAktuell.x + 2, pointAktuell.y + 2);
	}
}


// CXMLView drucken

BOOL CXMLView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CXMLView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CXMLView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Bereinigung nach dem Drucken einfgen
}


// CXMLView-Diagnose

#ifdef _DEBUG
void CXMLView::AssertValid() const
{
	CView::AssertValid();
}

void CXMLView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CXMLDoc* CXMLView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CXMLDoc)));
	return (CXMLDoc*)m_pDocument;
}
#endif //_DEBUG


// CXMLView-Meldungshandler

void CXMLView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein, und/oder benutzen Sie den Standard.
	CView::OnLButtonDown(nFlags, point);

	//Den Point in Document zufgen:
	this->GetDocument ()->AddPoint ( point.x, point.y);

	//Neuzeichnen:
	this->GetDocument()->UpdateAllViews (NULL);

	CView::OnLButtonDown(nFlags, point);
}
